<template>
  <div class="create-credential">
    <div class="container-fluid">
      <div class="row">
        <div class="col-12">
          <div class="title">Create new repository</div>
          <div class="subtitle">Create a new repository to push code to</div>
          <div class="input">
            <label>Name</label>
            <div class="input-wrapper">
              <input
                      id="repository-name"
                type="text"
                placeholder="Repository"
                v-model="displayName"
                @keyup.enter="createRepo"
              />
            </div>
          </div>
          <div class="input">
            <label>Url</label>
            <div class="input-wrapper" @click="$refs.slug.focus()">
              <span>https://scepter.dev/{{ project.name }}/</span
              ><input
                    id="repository-url"
                    ref="slug"
                type="text"
                placeholder="repository"
                v-model="name"
                @keyup.enter="createRepo"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
    <button class="button color-2 float-right" id="create-repository" @click="createRepo">
      Create Repository
    </button>
    <br /><br />
  </div>
</template>

<script>
import { mapActions } from "vuex";
export default {
  data() {
    return {
      displayName: "",
      name: ""
    };
  },
  props: {
    project: {
      required: true
    }
  },
  methods: {
    ...mapActions("projectModule", ["createRepository"]),
    createRepo() {
      const payload = {
        displayName: this.displayName,
        name: this.name
      };
      this.createRepository(payload).then(() => {
        this.$emit("close");
        this.$toasters["main"].success("Repository created!");
      }).catch((error) => {
        this.$toasters["main"].error(error.response.data.message);
      });
    }
  },
  watch: {
    displayName: function(newVal) {
      this.name = "";
      for (let i = 0; i < newVal.length; i++) {
        const char = newVal.charAt(i);
        switch (char) {
          case " ":
            this.name += "-";
            break;
          default:
            this.name += char.toLowerCase();
            break;
        }
      }
    }
  }
};
</script>

<style lang="scss">
.create-credential {
  padding-top: 10px;
  padding-bottom: 10px;
}
</style>
